eps = 0.01;
t = 2; 

offset_z = 2; // не менять, подогнано под корпус

mount_x = 42;
mount_y = 12;

hole_offset_x = 2.6;
hole_offset_y = 5;
hole_dia = 3.5;

vert_y = 15.5-t; // определяет высоту крепления bltouch

bltouch_x = 26;
bltouch_z = 11-t-offset_z;
bltouch_t = 4;   // толщина крепления для bltouch
bltouch_hole_offset_x = 4;

terminal_block_x = 13.5;
terminal_block_z = bltouch_z+t+2*eps;

difference() {
    union() {
        difference() {
            // крепление к корпусу головы
            cube([mount_x, mount_y, t], center = true);
            
            // отверстия под винты M3
            translate([mount_x/2-hole_offset_x, mount_y/2-hole_offset_y,0])
                cylinder(h=t*2, d = hole_dia, center = true, $fn = 25);
            translate([-mount_x/2+hole_offset_x, mount_y/2-hole_offset_y,0])
                cylinder(h=t*2, d = hole_dia, center = true, $fn = 25);
                
            // срезаем углы для печати без поддержек
            translate([-mount_x/2, -mount_y/2-2, 0])
                rotate([0, 0, 45+15])
                    cube([mount_y, mount_y, t+eps], center=true);
                    
            translate([mount_x/2, -mount_y/2-2, 0])
                rotate([0, 0, 45-15])
                    cube([mount_y, mount_y, t+eps], center=true);
        }
        
        // вертикальное смещение крепления
        translate([0, mount_y/2-vert_y/2, offset_z/2]) {
            difference() {
                cube([bltouch_x, vert_y, t+offset_z], center = true);
            
                // срезаем ~7 мм по высоте от толстой части
                translate([0,vert_y/2-(mount_y-7.5)/2+eps,t/2+eps])
                    cube([bltouch_x+eps, mount_y-7, offset_z], center=true);
                    
                // срезаем углы
                translate([bltouch_x/2-3, vert_y/2-3, t/2+eps])
                    rotate([0,0,45+15])
                        cube([mount_y, mount_y+2, offset_z], center=true);
                        
                translate([-bltouch_x/2+3, vert_y/2-3, t/2+eps])
                    rotate([0,0,45-15])
                        cube([mount_y+2, mount_y, offset_z], center=true);
            }
        }
           
        translate([0, mount_y/2-vert_y-bltouch_t/2, -(bltouch_z+t)/2+t/2+offset_z/2])
            difference() {
                // крепление bltouch
                cube([bltouch_x, bltouch_t, bltouch_z+t+offset_z], center = true);
                
                // крепежные отверстия bltouch под винты M3
                translate([bltouch_x/2-bltouch_hole_offset_x, 0, -t/2])
                    rotate([90, 0, 0])
                        cylinder(h = bltouch_t+eps, d = hole_dia, center = true, $fn = 25);
                translate([-bltouch_x/2+bltouch_hole_offset_x, 0, -t/2])
                    rotate([90, 0, 0])
                        cylinder(h = bltouch_t+eps, d = hole_dia, center = true, $fn = 25);
            }
    }
    
    // изначально "вырез под клеммник", но как позднее выяснилось не только под него - под сам bltouch тоже
    translate([0, mount_y/2-vert_y-bltouch_t/2, -terminal_block_z/2+offset_z/2+t/2+eps])
        cube([terminal_block_x, bltouch_t+eps, terminal_block_z+offset_z], center = true);
    
    // горизонтальная прорезь для крепления bltouch, она же прорезь для шлейфа
    translate([0, mount_y/2+2.95/2-vert_y, 0]) {
        // по факту прорезей две чтобы лучше закрепить "ножки" модели
        translate([0,0,t/2]) cube([22-2*2, 2.95, t+offset_z+eps], center = true);
        translate([0,0,t/2-2])cube([22, 2.95, t+offset_z+eps], center = true);
    }
}